﻿using System.Diagnostics;

namespace OBSBlur.Window;

public struct WindowInfo
{
    internal IntPtr WindowHandle { get; init; }
    public WINDOWPLACEMENT WindowPlacement { get; init; }
    public string WindowTitle { get; init; }
    public Process ProcessInfo { get; init; }

    public WindowInfo(IntPtr windowHandle, string windowTitle, Process processInfo, WINDOWPLACEMENT windowPlacement)
    {
        this.WindowHandle = windowHandle;
        this.ProcessInfo = processInfo;
        this.WindowPlacement = windowPlacement;
        this.WindowTitle = windowTitle;
    }

    public override string ToString()
    {
        const int cutoffStr = 17;
        string processNameStr = ProcessInfo.ProcessName.Substring(0, Math.Min(cutoffStr, ProcessInfo.ProcessName.Length));
        string windowTitleStr = WindowTitle.Substring(0, Math.Min(cutoffStr, WindowTitle.Length));
        return $"{WindowHandle,8} {ProcessInfo.Id,8} {processNameStr,cutoffStr} {windowTitleStr,-cutoffStr} {WindowPlacement}";
    }
}